Package com.documentum.fc.client

# Interface IDfPackage

All Superinterfaces:
  `IDfPersistentObject`, `IDfTypedObject`

public interface IDfPackage extends IDfPersistentObject
Interface definition for the type DmiPackage Description: This object cannot be saved.

- ## Field Summary

  ### Fields inherited from interface com.documentum.fc.client.IDfPersistentObject

  `CURRENCY_CHECK_ALWAYS, CURRENCY_CHECK_FIRST_ACCESS, CURRENCY_CHECK_NEVER, CURRENCY_CHECK_ONCE_PER_SCOPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `appendNote(String text, boolean persistent)`
  Adds a note to a package.
  `void`
  `appendNoteEx(IDfId annotationId, boolean persistent)`
  Adds a note to a package.
  `IDfTime`
  `getAcceptanceDate()`
  Returns the acceptance date, which identifies when a package arrived and was accepted by an input port.
  `int`
  `getActSeqno()`
  Returns the sequence number (r_act_seqno) of the activity in which the package is being handled.
  `IDfId`
  `getComponentChronId(int index)`
  Returns the component chronical id of one of the bound objects.
  `int`
  `getComponentChronIdCount()`
  Returns the number of bound objects in this package.
  `IDfId`
  `getComponentId(int index)`
  Returns the component id of one of the bound objects.
  `int`
  `getComponentIdCount()`
  Returns the number of bound objects in this package.
  `String`
  `getComponentName(int index)`
  Returns the component name, which is typically the object name of the object identified at the corresponding index position in r_component_id
  `IDfId`
  `getExecMethodId()`
  Retrieves the method id of the corresponding workflow object.
  `int`
  `getNoteCount()`
  Returns the number of notes in this package.
  `IDfTime`
  `getNoteCreationDate(int noteIndex)`
  Returns an IDfTime interface which contains the creation date of the specified note.
  `int`
  `getNoteFlag(int noteIndex)`
  Returns the special flags for a note.
  `IDfId`
  `getNoteId(int noteIndex)`
  Returns the object id of the dm_note object.
  `boolean`
  `getNotePersistance(int noteIndex)`
  Returns a boolean value to indicate whether the note is persistent across all activities.
  `String`
  `getNoteText(int noteIndex)`
  Returns a String containing the content of the specified note.
  `String`
  `getNoteWriter(int noteIndex)`
  Returns the name of the user who wrote the note.
  `int`
  `getPackageCount()`
  Returns the package count of a collection package.
  `int`
  `getPackageFlag()`
  Returns the package flag for the package (if it exists).
  `IDfId`
  `getPackageId(int index)`
  Rerturns the id of a package in a collection package.
  `String`
  `getPackageLabel(int index)`
  Returns the version label for the package (if it exists).
  `String`
  `getPackageName()`
  Returns the package name.
  `String`
  `getPackageOperation()`
  Returns the package operation, which is copied from the package definition upon creation of a package.
  `int`
  `getPackageOrder()`
  Returns the order number, which identifies where a package definition appears in the containing port definition.
  `String`
  `getPackageType()`
  Returns the package type, which is the type name of the bound components.
  `String`
  `getPortName()`
  Returns the name of the port of the activity runtime instance in which the package is being handled.
  `IDfId`
  `getWorkflowId()`
  Returns the workflow id.
  `boolean`
  `isManufactured()`
  This method returns `true` if this is a package that was manually created by the user and did not come in on an INPUT port.
  `void`
  `removeNote(int noteIndex)`
  Removes an existing note from a package.
  `void`
  `removeNoteEx(IDfId annotationId)`
  Removes an existing note from a package.

  ### Methods inherited from interface com.documentum.fc.client.IDfPersistentObject

  `addChildRelative, addParentRelative, apiExec, apiGet, apiSet, destroy, fetch, fetchWithCaching, getAttrAssistance, getAttrAssistanceWithValues, getAttrAsstDependencies, getChildRelatives, getParentRelatives, getPartition, getType, getValidator, getVStamp, getWidgetType, isDeleted, isDirty, isInstanceOf, isNew, isReplica, lock, lockEx, registerEvent, removeChildRelative, removeParentRelative, revert, save, setPartition, signoff, unRegisterEvent, unRegisterEventEx, validateAllRules, validateAttrRules, validateAttrRulesWithValue, validateAttrRulesWithValues, validateObjRules, validateObjRulesWithValues`

  ### Methods inherited from interface com.documentum.fc.client.IDfTypedObject

  `appendBoolean, appendDouble, appendId, appendInt, appendString, appendTime, appendValue, dump, enumAttrs, findAttrIndex, findBoolean, findDouble, findId, findInt, findString, findTime, findValue, getAllRepeatingStrings, getAttr, getAttrCount, getAttrDataType, getBoolean, getDouble, getId, getInt, getLong, getObjectId, getObjectSession, getOriginalSession, getRepeatingBoolean, getRepeatingDouble, getRepeatingId, getRepeatingInt, getRepeatingLong, getRepeatingString, getRepeatingTime, getRepeatingValue, getSession, getSessionManager, getString, getTime, getValue, getValueAt, getValueCount, hasAttr, insertBoolean, insertDouble, insertId, insertInt, insertString, insertTime, insertValue, isAttrRepeating, isNull, remove, removeAll, setBoolean, setDouble, setId, setInt, setNull, setRepeatingBoolean, setRepeatingDouble, setRepeatingId, setRepeatingInt, setRepeatingString, setRepeatingTime, setRepeatingValue, setSessionManager, setString, setTime, setValue, truncate`

- ## Method Details

  - ### appendNote

    int appendNote(String text, boolean persistent) throws DfException
    Adds a note to a package. This method creates a dm_note object whose content is the text from the method's `text` argument. The object is stored in the repository folder /Resources/user_name where user_name is the current user. The method then sets the r_note_id attribute of the package object to the object ID of the dm_note object. The `persistent` flag determines whether the note is sent only to the performer of the next activity or to the performers of all subsequent activities.
    Parameters:
      `text` - text of the note to add
      `persistent` - `true` to send the note to all remaining participants, `false` to send the note only to the next participant.
    Returns:
      0-based index of the new note
    Throws:
      `DfException` - if a server error occurs

  - ### appendNoteEx

    void appendNoteEx(IDfId annotationId, boolean persistent) throws DfException
    Adds a note to a package. The note object of the given id is stored in the repository folder /Resources/user_name where user_name is the current user. The method then sets the r_note_id attribute of the package object to the object ID of the dm_note object. The `persistent` flag determines whether the note is sent only to the performer of the next activity or to the performers of all subsequent activities.
    Parameters:
      `annotationId` - id of the note object to add
      `persistent` - `true` to send the note to all remaining participants, `false` to send the note only to the next participant.
    Throws:
      `DfException` - if a server error occurs

  - ### removeNote

    void removeNote(int noteIndex) throws DfException
    Removes an existing note from a package.

    The method detaches the note with the package, but it does not destroy the note itself.

    Only the user who added the note to a package can remove the note from the package.

    Parameters:
      `noteIndex` - the index of the note you want to remove from the package.
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getNoteCount()`

  - ### removeNoteEx

    void removeNoteEx(IDfId annotationId) throws DfException
    Removes an existing note from a package.

    The method detaches the note with the package, but it does not destroy the note itself.

    Only the user who added the note to a package can remove the note from the package.

    Parameters:
      `annotationId` - the id of the note object you want to remove from the package.
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getNoteCount()`

  - ### getExecMethodId

    IDfId getExecMethodId() throws DfException
    Retrieves the method id of the corresponding workflow object.
    Returns:
      the method id as an IDfId interface
    Throws:
      `DfException` - if a server error occurs

  - ### getNotePersistance

    boolean getNotePersistance(int noteIndex) throws DfException
    Returns a boolean value to indicate whether the note is persistent across all activities. A return value of `false` means that a note is only visible to performers of the immediately following activities.
    Parameters:
      `noteIndex` - the index of the note in the package
    Returns:
      `true` if the note is persistent; `false` otherwise
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getNoteCount()`

  - ### getNoteText

    String getNoteText(int noteIndex) throws DfException
    Returns a String containing the content of the specified note.
    Parameters:
      `noteIndex` - the index of the note in the package
    Returns:
      content the text of the note
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getNoteCount()`

  - ### getNoteCreationDate

    IDfTime getNoteCreationDate(int noteIndex) throws DfException
    Returns an IDfTime interface which contains the creation date of the specified note.
    Parameters:
      `noteIndex` - the index of the note in the package
    Returns:
      an IDfTime interface
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getNoteCount()`

  - ### getWorkflowId

    IDfId getWorkflowId() throws DfException
    Returns the workflow id.
    Returns:
      the workflow id of the object managing the package exchanges
    Throws:
      `DfException` - if a server error occurs

  - ### getActSeqno

    int getActSeqno() throws DfException
    Returns the sequence number (r_act_seqno) of the activity in which the package is being handled.
    Returns:
      the activity sequence number
    Throws:
      `DfException` - if a server error occurs

  - ### getPortName

    String getPortName() throws DfException
    Returns the name of the port of the activity runtime instance in which the package is being handled.
    Returns:
      the port name of the activity instance handling the package
    Throws:
      `DfException` - if a server error occurs

  - ### getPackageName

    String getPackageName() throws DfException
    Returns the package name.
    Returns:
      the name of the current package
    Throws:
      `DfException` - if a server error occurs

  - ### getPackageType

    String getPackageType() throws DfException
    Returns the package type, which is the type name of the bound components.
    Returns:
      the package type of the bound components
    Throws:
      `DfException` - if a server error occurs

  - ### getPackageOrder

    int getPackageOrder() throws DfException
    Returns the order number, which identifies where a package definition appears in the containing port definition.
    Returns:
      the package order number in the containing port definition
    Throws:
      `DfException` - if a server error occurs

  - ### getPackageOperation

    String getPackageOperation() throws DfException
    Returns the package operation, which is copied from the package definition upon creation of a package.
    Returns:
      the current package operation
    Throws:
      `DfException` - if a server error occurs

  - ### getAcceptanceDate

    IDfTime getAcceptanceDate() throws DfException
    Returns the acceptance date, which identifies when a package arrived and was accepted by an input port.
    Returns:
      an IDfTime interface containing the time when a package arrived and was accepted by an input port
    Throws:
      `DfException` - if a server error occurs

  - ### getComponentId

    IDfId getComponentId(int index) throws DfException
    Returns the component id of one of the bound objects.
    Parameters:
      `index` - the index of the bound object
    Returns:
      an IDfId interface containing the bound object
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getComponentIdCount()`

  - ### getComponentIdCount

    int getComponentIdCount() throws DfException
    Returns the number of bound objects in this package.
    Returns:
      the number of bound objects
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getComponentId(int)`

  - ### getComponentChronId

    IDfId getComponentChronId(int index) throws DfException
    Returns the component chronical id of one of the bound objects.
    Parameters:
      `index` - the index of the bound object
    Returns:
      an IDfId interface containing the bound object
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getComponentChronIdCount()`

  - ### getComponentChronIdCount

    int getComponentChronIdCount() throws DfException
    Returns the number of bound objects in this package.
    Returns:
      the number of bound objects
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getComponentChronId(int)`

  - ### getNoteCount

    int getNoteCount() throws DfException
    Returns the number of notes in this package.
    Returns:
      the number of notes in this package
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getNoteText(int)`
      - `getNotePersistance(int)`
      - `removeNote(int)`
      - `getNoteCreationDate(int)`
      - `getNoteWriter(int)`
      - `getNoteId(int)`
      - `getNoteFlag(int)`

  - ### getNoteWriter

    String getNoteWriter(int noteIndex) throws DfException
    Returns the name of the user who wrote the note.
    Parameters:
      `noteIndex` - the index of the note in the package
    Returns:
      the note writer user name
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getNoteCount()`

  - ### getNoteId

    IDfId getNoteId(int noteIndex) throws DfException
    Returns the object id of the dm_note object.
    Parameters:
      `noteIndex` - the index of the note in the package
    Returns:
      an IDfId interface containing the note object id
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getNoteCount()`

  - ### getNoteFlag

    int getNoteFlag(int noteIndex) throws DfException
    Returns the special flags for a note.

    A package carries some notes from one activity to another. It drops old notes (those added by previous activity performers) and carries only new notes (those added by the current activity performers) to the next activity. Turning on the keep flag of r_note_flag, however, changes this behavior and allows a note to be carried further down the stream. Such a note remains attached, until its keep flag gets turned off or the attached package is dropped.

         bit 1: keep flag
         bit 2: old (OFF) versus new note (ON)

    Parameters:
      `noteIndex` - the index of the note in the package
    Returns:
      the note flag
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getNoteCount()`

  - ### getPackageCount

    int getPackageCount() throws DfException
    Returns the package count of a collection package.

    At runtime, packages are delivered from one activity to the other through ports. A package can be either of the following forms:

         Single: a package that is bound with only one object.
         Collection: a package that is bound with a set of objects. A
         package with multiple bound objects is typically the result of a DQL query.

    Returns:
      the number of packages in the collection
    Throws:
      `DfException` - if a server error occurs

  - ### getPackageLabel

    String getPackageLabel(int index) throws DfException
    Returns the version label for the package (if it exists).
    Parameters:
      `index` - the index of the package label
    Returns:
      the version label
    Throws:
      `DfException` - if a server error occurs

  - ### getPackageId

    IDfId getPackageId(int index) throws DfException
    Rerturns the id of a package in a collection package. At run-time, packages are delivered from one activity to the other through ports. A package can be either of the following forms:

         Single: a package that is bound with only one object.
         Collection: a package that is bound with a set of objects. A collection
         package is typically the result of a DQL query.

    Parameters:
      `index` - the index of the package in the collection
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getPackageCount()`

  - ### isManufactured

    boolean isManufactured() throws DfException
    This method returns `true` if this is a package that was manually created by the user and did not come in on an INPUT port.
    Returns:
      `true` if this is a package that was manually created by the user; `false` otherwise.
    Throws:
      `DfException` - if a server error occurs.

  - ### getComponentName

    String getComponentName(int index) throws DfException
    Returns the component name, which is typically the object name of the object identified at the corresponding index position in r_component_id
    Returns:
      the component name
    Throws:
      `DfException`

  - ### getPackageFlag

    int getPackageFlag() throws DfException
    Returns the package flag for the package (if it exists).
    Returns:
      the package flag
    Throws:
      `DfException` - if a server error occurs